<?php
/*
Plugin Name: PicRetargetR
Plugin URI: http://resell-rights-weekly.com
Description: Facebook Image Retargeting Plugin
Version: 1.1.0
Author: RRW
Author URI: http://resell-rights-weekly.com
License: 
*/

// Prevent loading this file directly - Busted!
if ( ! class_exists( 'WP' ) )
{
	header( 'Status: 403 Forbidden' );
	header( 'HTTP/1.1 403 Forbidden' );
	exit;
}
function my_cam_plugin_url() {
			return plugins_url( basename( plugin_dir_path( __FILE__ ) ), basename( __FILE__ ) );

}
function cam_p_activate() {
	add_action( 'wp', 'cam_wp_rewrite' );
	// Activation code here...
}
function cam_wp_rewrite()
{
	global $wp_rewrite; 
	$wp_rewrite->flush_rules();    
}
register_activation_hook( __FILE__, 'cam_p_activate' );
// Optimize code for loading plugin files ONLY on admin side
// @see http://goo.gl/EhMFP
if ( defined( 'WP_ADMIN' ) && WP_ADMIN )
{
	// Script version, used to add version for scripts and styles
	define( 'ZDMB_VER', '2.0.2' );

	// Define plugin URLs, for fast enqueuing scripts and styles
	if ( ! defined( 'ZDMB_URL' ) )
		define( 'ZDMB_URL', plugin_dir_url( __FILE__ ) );
	define( 'ZDMB_JS_URL', trailingslashit( ZDMB_URL . 'js' ) );
	define( 'ZDMB_CSS_URL', trailingslashit( ZDMB_URL . 'css' ) );

	// Plugin paths, for including files
	if ( ! defined( 'ZDMB_DIR' ) )
		define( 'ZDMB_DIR', plugin_dir_path( __FILE__ ) );
	define( 'ZDMB_INC_DIR', trailingslashit( ZDMB_DIR . 'inc' ) );
	define( 'ZDMB_FIELDS_DIR', trailingslashit( ZDMB_INC_DIR . 'fields' ) );
	define( 'ZDMB_CLASSES_DIR', trailingslashit( ZDMB_INC_DIR . 'classes' ) );

	// Include field classes
	foreach ( glob( ZDMB_FIELDS_DIR . '*.php' ) as $file )
	{
		require_once $file;
	}
	
	// Include plugin main file
	require_once ZDMB_CLASSES_DIR . 'meta-box.php';
	include_once ZDMB_CLASSES_DIR . 'image-class.php';
}


/**
 * Adds [whatever] to the global debug array
 *
 * @param mixed  $input
 * @param string $print_or_export
 *
 * @return array
 */
function zdmb_debug( $input, $print_or_export = 'print' )
{
	global $zdmb_debug;

	$html = 'print' === $print_or_export ? print_r( $input, true ) : var_export( $input, true );

	return $zdmb_debug[] = $html;
}

/**
 * Prints or exports the content of the global debug array at the 'shutdown' hook
 *
 * @return void
 */
function zdmb_debug_print()
{
	global $zdmb_debug;
	if ( ! $zdmb_debug || ( is_user_logged_in() && is_user_admin() ) )
		return;

	$html  = '<h3>' . __( 'ZDN_Meta_Box Debug:', 'zdmb' ) . '</h3><pre>';
	foreach ( $zdmb_debug as $debug )
	{
		$html .= "{$debug}<hr />";
	}
	$html .= '</pre>';

	die( $html );
}

add_action( 'shutdown', 'zdmb_debug_print', 999 );
add_action( 'init', 'cam_create_post_types' );
function cam_create_post_types()
{
	register_post_type('campaign',
		array(
			'menu_icon' => plugins_url( '/images/icon-campaign.png', __FILE__ ),
			'label' => 'Campaigns',
			'description' => '',
			'public' => true,
			'show_ui' => true,
			'show_in_menu' => true,
			'capability_type' => 'page',
			//'rewrite' => true,
			'hierarchical' => false,
			'query_var' => true,
			'supports'      => array( 'title', 'editor', 'thumbnail'),
			'labels' => array (
				'name' => 'Campaigns',
				'singular_name' => 'Campaigns',
				'menu_name' => 'PicRetargetR',
				'add_new' => 'Create Campaign',
				'add_new_item' => 'Create Campaign',
				'edit' => 'Edit Campaign',
				'edit_item' => 'Edit Campaign',
				'new_item' => 'New Campaign',
				'view' => 'View Campaign',
				'view_item' => 'View Campaign',
				'search_items' => 'Search Campaigns',
				'not_found' => 'No Campaigns Found',
				'not_found_in_trash' => 'No Campaigns Found in Trash',
				'parent' => 'Parent Campaign',
			),
			'register_meta_box_cb' => 'cam_add_metaboxes'
		)
	);
	/*register_taxonomy('benefit-cats',
		array (
	  		0 => 'benefits',
		),
		array(
			'hierarchical' => true,
			'label' => 'Discount Categories',
			'show_ui' => true,
			'query_var' => true,
			'singular_label' => 'Discount'
		)
	);*/
	
}
add_theme_support( 'post-thumbnails',array( 'campaign' ) ); 
add_action( 'init', 'add_custom_fields' );
add_action( 'add_meta_boxes', 'cam_add_metaboxes' );
// Add the Events Meta Boxes
function cam_add_metaboxes() {
	add_meta_box('cam_campaign_location', 'Share on FB', 'cam_campaign_location', 'campaign', 'side', 'default');
}
function cam_campaign_location( $post ) {
	//global $post;
	if(isset($post->ID) && $post->ID &&  $post->post_status== "publish")	
	{
		echo cam_fb_share($post->ID);
	}	
	else
	{
		//echo "Post"
	}		
}
add_action( 'init', 'add_custom_fields' );

function add_custom_fields() {
	$prefix = 'cam';
	global $meta_boxes;
	$meta_boxes = array();
	$meta_boxes[] = array(
		'id' => 'campaign-options',
		'title' => 'Retargeting Detail',
		'pages' => array( 'campaign' ),
		'context' => 'normal',
		'priority' => 'high',
		'fields' => array(
			array(
				'name'		=> 'Campaign URL',
				'id'		=> $prefix . '_campaign_url',
				'desc'		=> '',
				'type'		=> 'text',
				'size' => "80",			
			),
			array(
				'name'		=> 'Header Tracking Code',
				'id'		=> $prefix . '_header_tracking',
				'desc'		=> '',
				'type'		=> 'textarea',
				'std'		=> '',
				'rows' => "5",		
				'cols' => "80",	
			),
		array(
					'name'		=> 'Footer Tracking Code',
					'id'		=> $prefix . '_footer_tracking',
					'desc'		=> '',
					'type'		=> 'textarea',
					'std'		=> '',
					'rows' =>"5",
				),		
					
			
		)
	);
	
}

function YOUR_PREFIX_register_meta_boxes()
{
	global $meta_boxes;
	if ( class_exists( 'ZDN_Meta_Box' ) )
	{
		foreach ( $meta_boxes as $meta_box )
		{
			new ZDN_Meta_Box( $meta_box );
		}
	}
}
add_action( 'admin_init', 'YOUR_PREFIX_register_meta_boxes' );
if( class_exists( 'kdMultipleFeaturedImages' ) ) {
			$args2 = array(
					'id' => 'featured-image-1',
					'post_type' => 'campaign',      // Set this to post or page
					'labels' => array(
						'name'      => 'Image',
						'set'       => 'Set the image',
						'remove'    => 'Remove the image',
						'use'       => 'Use as image',
					)
			);
			new kdMultipleFeaturedImages( $args2 );
}
if(!is_admin())
add_action( 'wp', 'cam_wp_loaded' );
function cam_wp_loaded()
{	
	global $post;
	if(get_post_type()!= "campaign")
		return;
	$p_id = $post->ID;
	$cam_url = get_post_meta( get_the_ID(), 'cam_campaign_url', true );
	if($cam_url=='' || empty($cam_url))
		return ''; 
	$cam_hedaer = get_post_meta( get_the_ID(), 'cam_header_tracking', true );
	$cam_footer = get_post_meta( get_the_ID(), 'cam_footer_tracking', true );
	ob_start();
	?>
	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
		<html xmlns="http://www.w3.org/1999/xhtml">
		<head>
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
		<title><?php the_title();?></title>
		<meta property="og:title" content="<?php the_title();?>" />
		<meta property="og:type" content="article" />
		<?php
		$ImageA = get_associated_media(get_the_ID());
         if(isset($ImageA[0]))
	   		$ImageURL =  $ImageA[0];
		 if(isset($ImageA[1]))
	   		$ImageWidth =  $ImageA[1];
			
		 if(isset($ImageA[2]))
	   		$ImageHeight =  $ImageA[2];		
		?>
		<meta property="og:image" content="<?php
		echo $ImageURL;
		?>" />
        <meta property="og:image:width" content="<?php echo $ImageWidth; ?>">
        <meta property="og:image:height" content="<?php echo $ImageHeight; ?>">
		<meta property="og:url" content="<?php the_permalink();?>" />
		<meta property="og:description" content="<?php echo htmlentities($post->post_content);?>" />
		<script>
		function  delaydGoCam(){
			window.location ="<?php echo $cam_url;?>"
		}
		</script>
		<?php
		if($cam_hedaer)
		{
		echo $cam_hedaer;
		}
		?>	
		</head>					
		<body onload="setTimeout('delaydGoCam()',200)">
		<?php
		if($cam_footer)
		{
		echo $cam_footer;
		}
		//<script>window.location.href='<?php echo $cam_url;';< /s cript >	
		?>		
		</body>
	</html>
	<?php
	$output_string = ob_get_contents();
    ob_end_clean();
	echo $output_string;
	die;
}

function cam_fb_share($post_ID)
{
ob_start();
?><script>
	function openFB()
	{
		var newWin;
		newWin = window.open('https://www.facebook.com/sharer.php?u=<?php echo get_permalink($post_ID); ?>' , 'fbwindow', 'scrollbars=no,width=500,height=510');
		if (window.focus) {newWin.focus()}
	}											
	</script>									
	<?php
	echo $fb = '<a href="javascript:;" onclick ="return openFB();" >Share on FB</a>';
	$output_string = ob_get_contents();
    ob_end_clean();
	return $output_string ; 	
}

function cam_social_update_messages( $messages ) {

  		global $post, $post_ID;
		$post_type = get_post_type( $post_ID );
		if($post->post_type!='campaign')
			return $messages;


		$head = "<h1 style='margin:10px 0'>Congrats on your new post! Be sure to share it!</h1>";

		$sep = "&nbsp;&nbsp;";

		$fb = cam_fb_share($post_ID);
		

		$a = sprintf( __('Page updated. <a href="%s">View page</a>'), esc_url( get_permalink($post_ID) ) );		

		$b = sprintf( __('Post updated. <a href="%s">View post</a>'), esc_url( get_permalink($post_ID) ) );

		

		$a .= $head.$sep.$fb.$sep;

		$b .= $head.$sep.$fb.$sep;

		

		unset($head,$sep,$fb);

		

		// pages

		$messages['page'] = array(

			 0 => '', // Unused. Messages start at index 1.

			 1 => $a,

			 2 => __('Custom field updated.'),

			 3 => __('Custom field deleted.'),

			 4 => __('Page updated.'),

			 5 => isset($_GET['revision']) ? sprintf( __('Page restored to revision from %s'), wp_post_revision_title( (int) $_GET['revision'], false ) ) : false,

			 6 => str_replace("updated","published",$a),

			 7 => __('Page saved.'),

			 8 => sprintf( __('Page submitted. <a target="_blank" href="%s">Preview page</a>'), esc_url( add_query_arg( 'preview', 'true', get_permalink($post_ID) ) ) ),

			 9 => sprintf( __('Page scheduled for: <strong>%1$s</strong>. <a target="_blank" href="%2$s">Preview page</a>'), date_i18n( __( 'M j, Y @ G:i' ), strtotime( $post->post_date ) ), esc_url( get_permalink($post_ID) ) ),

			10 => sprintf( __('Page draft updated. <a target="_blank" href="%s">Preview page</a>'), esc_url( add_query_arg( 'preview', 'true', get_permalink($post_ID) ) ) ),

		);

		unset($a);

		// posts

		$messages['post'] = array(

			 0 => '', // Unused. Messages start at index 1.

			 1 => $b,

			 2 => __('Custom field updated.'),

			 3 => __('Custom field deleted.'),

			 4 => __('Page updated.'),

			 5 => isset($_GET['revision']) ? sprintf( __('Page restored to revision from %s'), wp_post_revision_title( (int) $_GET['revision'], false ) ) : false,

			 6 => str_replace("updated","published",$b),

			 7 => __('Page saved.'),

			 8 => sprintf( __('Page submitted. <a target="_blank" href="%s">Preview page</a>'), esc_url( add_query_arg( 'preview', 'true', get_permalink($post_ID) ) ) ),

			 9 => sprintf( __('Page scheduled for: <strong>%1$s</strong>. <a target="_blank" href="%2$s">Preview page</a>'), date_i18n( __( 'M j, Y @ G:i' ), strtotime( $post->post_date ) ), esc_url( get_permalink($post_ID) ) ),

			10 => sprintf( __('Page draft updated. <a target="_blank" href="%s">Preview page</a>'), esc_url( add_query_arg( 'preview', 'true', get_permalink($post_ID) ) ) ),

		);

		unset($b);



  return $messages;

}

add_filter( 'post_updated_messages', 'cam_social_update_messages' );

function get_associated_media($id) {
    // check if page
	$key_id ="kd_featured-image-1_campaign_id";
	$image_id = get_post_meta( 
                    $id,
                    $key_id,
                    true
            );
	if( $image_id && get_post( $image_id ) ) 
	{
	   $thumbnail = wp_get_attachment_image_src( $image_id,'full' ); //array( 266, 266 )	  
	}
	if(isset($thumbnail))
	   	return $thumbnail;						
	//    unlink(get_attached_file($file->ID));
}